diff --git a/src/qemu/qemu_capabilities.c b/src/qemu/qemu_capabilities.c
index 30dc33a..610c6af 100644
--- a/src/qemu/qemu_capabilities.c
+++ b/src/qemu/qemu_capabilities.c
@@ -328,6 +328,7 @@ VIR_ENUM_IMPL(virQEMUCaps, QEMU_CAPS_LAST,
               "device-tray-moved-event",
               "nec-usb-xhci-ports",
               "virtio-scsi-pci.iothread",
+              "name-guest",
     );
 
 
@@ -2666,6 +2667,7 @@ static struct virQEMUCapsCommandLineProps virQEMUCapsCommandLine[] = {
     { "spice", "gl", QEMU_CAPS_SPICE_GL },
     { "chardev", "logfile", QEMU_CAPS_CHARDEV_LOGFILE },
     { "name", "debug-threads", QEMU_CAPS_NAME_DEBUG_THREADS },
+    { "name", "guest", QEMU_CAPS_NAME_GUEST },
 };
 
 static int
diff --git a/src/qemu/qemu_capabilities.h b/src/qemu/qemu_capabilities.h
index e7d0a60..9145f2d 100644
--- a/src/qemu/qemu_capabilities.h
+++ b/src/qemu/qemu_capabilities.h
@@ -359,6 +359,7 @@ typedef enum {
     QEMU_CAPS_DEVICE_TRAY_MOVED, /* DEVICE_TRAY_MOVED event */
     QEMU_CAPS_NEC_USB_XHCI_PORTS, /* -device nec-usb-xhci.p3 ports setting */
     QEMU_CAPS_VIRTIO_SCSI_IOTHREAD, /* virtio-scsi-{pci,ccw}.iothread */
+    QEMU_CAPS_NAME_GUEST, /* -name guest= */
 
     QEMU_CAPS_LAST /* this must always be the last item */
 } virQEMUCapsFlags;
diff --git a/src/qemu/qemu_command.c b/src/qemu/qemu_command.c
index 6b89508..0461a2f 100644
--- a/src/qemu/qemu_command.c
+++ b/src/qemu/qemu_command.c
@@ -6871,6 +6871,10 @@ qemuBuildNameCommandLine(virCommandPtr cmd,
 
     virCommandAddArg(cmd, "-name");
 
+    /* The 'guest' option let's us handle a name with '=' embedded in it */
+    if (virQEMUCapsGet(qemuCaps, QEMU_CAPS_NAME_GUEST))
+        virBufferAddLit(&buf, "guest=");
+
     qemuBufferEscapeComma(&buf, def->name);
 
     if (cfg->setProcessName &&
diff --git a/tests/qemucapabilitiesdata/caps_2.1.1-1.x86_64.xml b/tests/qemucapabilitiesdata/caps_2.1.1-1.x86_64.xml
index 4663e19..2428aff 100644
--- a/tests/qemucapabilitiesdata/caps_2.1.1-1.x86_64.xml
+++ b/tests/qemucapabilitiesdata/caps_2.1.1-1.x86_64.xml
@@ -168,6 +168,7 @@
   <flag name='debug-threads'/>
   <flag name='device-tray-moved-event'/>
   <flag name='nec-usb-xhci-ports'/>
+  <flag name='name-guest'/>
   <version>2001001</version>
   <kvmVersion>0</kvmVersion>
   <package></package>
diff --git a/tests/qemucapabilitiesdata/caps_2.4.0-1.x86_64.xml b/tests/qemucapabilitiesdata/caps_2.4.0-1.x86_64.xml
index a8df7e1..68ea0de 100644
--- a/tests/qemucapabilitiesdata/caps_2.4.0-1.x86_64.xml
+++ b/tests/qemucapabilitiesdata/caps_2.4.0-1.x86_64.xml
@@ -181,6 +181,7 @@
   <flag name='device-tray-moved-event'/>
   <flag name='nec-usb-xhci-ports'/>
   <flag name='virtio-scsi-pci.iothread'/>
+  <flag name='name-guest'/>
   <version>2004000</version>
   <kvmVersion>0</kvmVersion>
   <package></package>
diff --git a/tests/qemucapabilitiesdata/caps_2.5.0-1.x86_64.xml b/tests/qemucapabilitiesdata/caps_2.5.0-1.x86_64.xml
index 2160173..73f0147 100644
--- a/tests/qemucapabilitiesdata/caps_2.5.0-1.x86_64.xml
+++ b/tests/qemucapabilitiesdata/caps_2.5.0-1.x86_64.xml
@@ -182,6 +182,7 @@
   <flag name='device-tray-moved-event'/>
   <flag name='nec-usb-xhci-ports'/>
   <flag name='virtio-scsi-pci.iothread'/>
+  <flag name='name-guest'/>
   <version>2004000</version>
   <kvmVersion>0</kvmVersion>
   <package></package>
diff --git a/tests/qemucapabilitiesdata/caps_2.6.0-1.aarch64.xml b/tests/qemucapabilitiesdata/caps_2.6.0-1.aarch64.xml
index f4e6db1..362ec1c 100644
--- a/tests/qemucapabilitiesdata/caps_2.6.0-1.aarch64.xml
+++ b/tests/qemucapabilitiesdata/caps_2.6.0-1.aarch64.xml
@@ -158,6 +158,7 @@
   <flag name='device-tray-moved-event'/>
   <flag name='nec-usb-xhci-ports'/>
   <flag name='virtio-scsi-pci.iothread'/>
+  <flag name='name-guest'/>
   <version>2005094</version>
   <kvmVersion>0</kvmVersion>
   <package></package>
diff --git a/tests/qemucapabilitiesdata/caps_2.6.0-1.ppc64le.xml b/tests/qemucapabilitiesdata/caps_2.6.0-1.ppc64le.xml
index 96a02a5..1d5d670 100644
--- a/tests/qemucapabilitiesdata/caps_2.6.0-1.ppc64le.xml
+++ b/tests/qemucapabilitiesdata/caps_2.6.0-1.ppc64le.xml
@@ -152,6 +152,7 @@
   <flag name='device-tray-moved-event'/>
   <flag name='nec-usb-xhci-ports'/>
   <flag name='virtio-scsi-pci.iothread'/>
+  <flag name='name-guest'/>
   <version>2005094</version>
   <kvmVersion>0</kvmVersion>
   <package></package>
diff --git a/tests/qemucapabilitiesdata/caps_2.6.0-1.x86_64.xml b/tests/qemucapabilitiesdata/caps_2.6.0-1.x86_64.xml
index 9024d63..5970d19 100644
--- a/tests/qemucapabilitiesdata/caps_2.6.0-1.x86_64.xml
+++ b/tests/qemucapabilitiesdata/caps_2.6.0-1.x86_64.xml
@@ -187,6 +187,7 @@
   <flag name='device-tray-moved-event'/>
   <flag name='nec-usb-xhci-ports'/>
   <flag name='virtio-scsi-pci.iothread'/>
+  <flag name='name-guest'/>
   <version>2005050</version>
   <kvmVersion>0</kvmVersion>
   <package></package>
diff --git a/tests/qemucapabilitiesdata/caps_2.6.0-2.aarch64.xml b/tests/qemucapabilitiesdata/caps_2.6.0-2.aarch64.xml
index f4d60d1..2138049 100644
--- a/tests/qemucapabilitiesdata/caps_2.6.0-2.aarch64.xml
+++ b/tests/qemucapabilitiesdata/caps_2.6.0-2.aarch64.xml
@@ -158,6 +158,7 @@
   <flag name='device-tray-moved-event'/>
   <flag name='nec-usb-xhci-ports'/>
   <flag name='virtio-scsi-pci.iothread'/>
+  <flag name='name-guest'/>
   <version>2005094</version>
   <kvmVersion>0</kvmVersion>
   <package></package>
diff --git a/tests/qemucaps2xmldata/all_1.6.0-1.caps b/tests/qemucaps2xmldata/all_1.6.0-1.caps
index 1484c79..d39d0be 100644
--- a/tests/qemucaps2xmldata/all_1.6.0-1.caps
+++ b/tests/qemucaps2xmldata/all_1.6.0-1.caps
@@ -125,4 +125,5 @@
     <flag name='pvpanic'/>
     <flag name='reboot-timeout'/>
     <flag name='enable-fips'/>
+    <flag name='name-guest'/>
   </qemuCaps>
diff --git a/tests/qemucaps2xmldata/nodisksnapshot_1.6.0-1.caps b/tests/qemucaps2xmldata/nodisksnapshot_1.6.0-1.caps
index 8bd8a18..5a0372c 100644
--- a/tests/qemucaps2xmldata/nodisksnapshot_1.6.0-1.caps
+++ b/tests/qemucaps2xmldata/nodisksnapshot_1.6.0-1.caps
@@ -124,4 +124,5 @@
     <flag name='pvpanic'/>
     <flag name='reboot-timeout'/>
     <flag name='enable-fips'/>
+    <flag name='name-guest'/>
   </qemuCaps>
diff --git a/tests/qemuxml2argvdata/qemuxml2argv-name-escape.args b/tests/qemuxml2argvdata/qemuxml2argv-name-escape.args
index b50b8c4..b59706c 100644
--- a/tests/qemuxml2argvdata/qemuxml2argv-name-escape.args
+++ b/tests/qemuxml2argvdata/qemuxml2argv-name-escape.args
@@ -5,16 +5,16 @@ USER=test \
 LOGNAME=test \
 QEMU_AUDIO_DRV=none \
 /usr/bin/qemu \
--name foo,,bar,debug-threads=on \
+-name guest=foo=1,,bar=2,debug-threads=on \
 -S \
--object secret,id=masterKey0,format=raw,file=/tmp/lib/domain--1-foo,,\
-bar/master-key.aes \
+-object secret,id=masterKey0,format=raw,file=/tmp/lib/domain--1-foo=1,,\
+bar=2/master-key.aes \
 -M pc \
 -m 214 \
 -smp 1 \
 -uuid c7a5fdbd-edaf-9455-926a-d65c16db1809 \
 -nodefaults \
--chardev socket,id=charmonitor,path=/tmp/lib/domain--1-foo,,bar/monitor.sock,\
+-chardev socket,id=charmonitor,path=/tmp/lib/domain--1-foo=1,,bar=2/monitor.sock,\
 server,nowait \
 -mon chardev=charmonitor,id=monitor,mode=readline \
 -no-acpi \
diff --git a/tests/qemuxml2argvdata/qemuxml2argv-name-escape.xml b/tests/qemuxml2argvdata/qemuxml2argv-name-escape.xml
index e263553..5e8c747 100644
--- a/tests/qemuxml2argvdata/qemuxml2argv-name-escape.xml
+++ b/tests/qemuxml2argvdata/qemuxml2argv-name-escape.xml
@@ -1,5 +1,5 @@
 <domain type='qemu'>
-  <name>foo,bar</name>
+  <name>foo=1,bar=2</name>
   <uuid>c7a5fdbd-edaf-9455-926a-d65c16db1809</uuid>
   <memory unit='KiB'>219100</memory>
   <currentMemory unit='KiB'>219100</currentMemory>
diff --git a/tests/qemuxml2argvtest.c b/tests/qemuxml2argvtest.c
index 5d15dfd..68f0a84 100644
--- a/tests/qemuxml2argvtest.c
+++ b/tests/qemuxml2argvtest.c
@@ -1894,7 +1894,8 @@ mymain(void)
                               NONE);
 
     DO_TEST("name-escape", QEMU_CAPS_NAME_DEBUG_THREADS,
-            QEMU_CAPS_OBJECT_SECRET, QEMU_CAPS_CHARDEV, QEMU_CAPS_VNC);
+            QEMU_CAPS_OBJECT_SECRET, QEMU_CAPS_CHARDEV, QEMU_CAPS_VNC,
+            QEMU_CAPS_NAME_GUEST);
     DO_TEST("debug-threads", QEMU_CAPS_NAME_DEBUG_THREADS);
 
     DO_TEST("master-key", QEMU_CAPS_OBJECT_SECRET);